#include <stdio.h>

#define FAST_CRC16
//#define SLOW_CRC16
extern unsigned short __checksum;

extern unsigned short slow_crc16(unsigned short, unsigned long, unsigned long);
extern unsigned short fast_crc16(unsigned short, unsigned long, unsigned long);

const int zero=0;


void main(void)
{
     unsigned short sum=0;

#ifdef SLOW_CRC16
     sum = slow_crc16(sum, 0x3100, 0xFFDD-0x3100+1);
     sum = slow_crc16(sum, 0xFFFE, 0x1FFFF-0xFFFE+1);
     sum = slow_crc16(sum, zero,2);

#elif defined FAST_CRC16
     sum = fast_crc16(sum, 0x3100, 0xFFDD-0x3100+1);
     sum = fast_crc16(sum, 0xFFFE, 0x1FFFF-0xFFFE+1);

#endif

     if(sum!=__checksum)
          printf("***Checksum failed: %hx instead of %hx!***\n",sum, __checksum);
     else
          printf("***Checksum is correct!***\n");
}
